/**
 * @Author Angus <angusyoung@mrxcool.com>
 * @Description Sa.UI.js for Native
 * @Since 2019/9/4
 */


(function (root, name, factory) {
	if (typeof define === 'function' && define.amd) {
		define(factory);
	}
	else if (typeof module != 'undefined') {
		module.exports = factory();
	}
	else {
		root[name] = factory();
	}
})(this, 'saui', function () {
	console.info('\
		┏━━━┓    ┏┓ ┏┓┏━━┓\n\
		┃┏━┓┃    ┃┃ ┃┃┗┫┣┛\n\
		┃┗━━┓┏━━┓┃┃ ┃┃ ┃┃ \n\
		┗━━┓┃┃┏┓┃┃┃ ┃┃ ┃┃ \n\
		┃┗━┛┃┃┏┓┃┃┗━┛┃┏┫┣┓\n\
		┗━━━┛┗┛┗┛┗━━━┛┗━━┛');

	window.onload = function (ev) {
		/* 信息提示 */
		document.querySelectorAll('[role="tooltip"]').forEach(function (item) {
			item.addEventListener('mouseenter', function () {
				var $This = this;
				$This.setAttribute('data-active', true);
				var $Next = $This.nextElementSibling;
				switch ($This.dataset['placement']) {
					case 'top':
						$Next.style.top = $This.offsetTop - $Next.offsetHeight - 5 + 'px';
						$Next.style.left = $This.offsetLeft + $This.offsetWidth / 2 - $Next.offsetWidth / 2 + 'px';
						break;
					case 'bottom':
						$Next.style.top = $This.offsetTop + $This.offsetHeight + 'px';
						$Next.style.left = $This.offsetLeft + $This.offsetWidth / 2 - $Next.offsetWidth / 2 + 'px';
						break;
					case 'left':
						$Next.style.top = $This.offsetTop + $This.offsetHeight / 2 - $Next.offsetHeight / 2 + 'px';
						$Next.style.left = $This.offsetLeft - $Next.offsetWidth - 5 + 'px';
						break;
					case 'right':
						$Next.style.top = $This.offsetTop + $This.offsetHeight / 2 - $Next.offsetHeight / 2 + 'px';
						$Next.style.left = $This.offsetLeft + $This.offsetWidth + 'px';
						break;
				}
			});
			item.addEventListener('mouseleave', function () {
				this.removeAttribute('data-active');
			});
		});


		/* 下拉菜单 */
		/* 日历控件 */
		document.body.addEventListener('click', function (ev) {
			console.log(ev.target);
			// '[role="calendar"]:not([open])',
			// new Calendar(this);
		});
	};


	/* 日历控件 */
	function Calendar(oTrigger) {
		this.id = Math.random().toString().substr(2);
		this.$el = $(oTrigger);
		this.options = this.getOption();
		// console.log(this.options);
		this.resetDate();

		var $panel = this.$parent = $(
			'<div class="date-panel card">' +
			'  <div class="pull-left">' +
			'     <a href="#" title="上一年" role-action="prevYear"><i class="sa-icon sa-icon-fw sa-icon-angle-double-left"></i></a>' +
			'     <a href="#" title="上一月" role-action="prevMonth"><i class="sa-icon sa-icon-fw sa-icon-angle-left"></i></a>' +
			'  </div>' +
			'  <div class="pull-right">' +
			'     <a href="#" title="下一月" role-action="nextMonth"><i class="sa-icon sa-icon-fw sa-icon-angle-right"></i></a>' +
			'     <a href="#" title="下一年" role-action="nextYear"><i class="sa-icon sa-icon-fw sa-icon-angle-double-right"></i></a>' +
			'  </div>' +
			'</div>');
		this.$container = $('<div class="calendar card-body"></div>');
		this.$container.appendTo($panel);

		if (!this.options.autoClose) {
			var _html = '<form class="form card-foot">' +
				(this.options.allowEdit ?
						(this.options.isRange ?
								(
									'<div class="pull-left">' +
									(this.options.showTime ?
											(
												'  <input type="datetime-local"'
												+ (this.options.showSecond ? ' step="1"' : '')
												+ (this.options.min ? ' min="' + this.options.min + '"' : '')
												+ (this.options.max ? ' max="' + this.options.max + '"' : '')
												+
												' value="' + this.startDate + 'T' + this.selectStartTime + '">' +
												'-' +
												'  <input type="datetime-local"'
												+ (this.options.showSecond ? ' step="1"' : '')
												+ (this.options.min ? ' min="' + this.options.min + '"' : '')
												+ (this.options.max ? ' max="' + this.options.max + '"' : '')
												+
												' value="' + this.endDate + 'T' + this.selectEndTime + '">'
											)
											: (
												'  <input type="date"'
												+ (this.options.min ? ' min="' + this.options.min + '"' : '')
												+ (this.options.max ? ' max="' + this.options.max + '"' : '')
												+
												' value="' + this.startDate + '">' +
												'-' +
												'  <input type="date"'
												+ (this.options.min ? ' min="' + this.options.min + '"' : '')
												+ (this.options.max ? ' max="' + this.options.max + '"' : '')
												+
												' value="' + this.endDate + '">'
											)
									) +
									'  <span class="bg-error">日期格式填写错误</span>' +
									'</div>'
								)
								: (this.options.showTime ?
										(
											'<div class="pull-left">' +
											'  <input type="time"' + (this.options.showSecond ? ' step="1"' : '') + ' value="' + this.selectStartTime + '">' +
											'</div>'
										) : ''
								)
						)
						: ''
				) +
				'  <div class="pull-right">' +
				(
					this.options.todayBtn ?
						'<button type="button" role-action="today">今天</button>'
						: ''
				) +
				'     <button type="button" class="btn btn-primary" role-action="update">确定</button>' +
				'  </div>' +
				'</form>';

			$panel.append(_html);
		}

		this.init();
	}

	Calendar.prototype = {
		start          : true,
		startDate      : '2000-01-01',
		endDate        : '2000-01-01',
		selectStartTime: '08:00:00',
		selectEndTime  : '08:00:00',
		cenMonth       : 0,
		preMonth       : 0,
		__check_version: function () {
			var _ua = navigator.userAgent.toLowerCase();
			if (_ua.indexOf('firefox') > -1) {
				return 'Firefox';
			}
			else if (_ua.indexOf('chrome') > -1) {
				return 'Chrome';
			}
			else if (_ua.indexOf('safari') > -1) {
				return 'Safari';
			}
			else {
				return 'Other';
			}
		},
		__date_string  : function (sDate, sType) {
			var _date = new Date(sDate);
			switch (sType) {
				case 'D':
					return _date.toLocaleString('nu', {
						hour12: false,
						year  : 'numeric',
						month : '2-digit',
						day   : '2-digit'
					}).replace(/\//g, '-');
				case 'T':
					return _date.toLocaleString('nu', {
						hour12: false,
						hour  : '2-digit',
						minute: '2-digit',
						second: '2-digit'
					});
			}
		},
		__format_string: function (sTime, sNormal) {
			// 将一个合法日期转换为完整的 yyyy-MM-ddThh:mm:ss 格式
			return sTime.replace(
				/^\d{4}-[01]\d-[0123]\d(T[012][0123]:[0-5]\d:[0-5]\d)?$/,
				function (sMatch, $1) {
					var _result, _date;
					_date = new Date(sMatch);
					_result = _date.getFullYear() + '-' + ('0' + (_date.getMonth() + 1)).slice(-2) + '-' + ('0' + _date.getDate()).slice(-2) + 'T';
					if ($1) {
						_result += ('0' + _date.getHours()).slice(-2) + ':' + ('0' + _date.getMinutes()).slice(-2) + ':' + ('0' + _date.getSeconds()).slice(-2);
					}
					else {
						_result += (sNormal || '00:00:00')
					}
					return _result;
				}
			);
		},
		__prefix       : function (sString) {
			if (!sString) {
				return '';
			}
			if (sString.indexOf(' ') > 0) {
				sString = sString.split(' ').join('T');
				if (sString.length < 16) {
					sString += ':00';
				}
				// 为 Safari 加上当前时区
				if (this.__check_version() === 'Safari') {
					// 时差，标准时间-本地时间 得出，单位分钟
					var nDiffHour = Math.round(new Date().getTimezoneOffset() / 60);
					if (nDiffHour > 0) {
						sString += '-' + ('0' + nDiffHour).slice(-2) + ':00';
					}
					else {
						sString += '+' + ('0' + Math.abs(nDiffHour)).slice(-2) + ':00';
					}
				}
			}
			return sString;
		},
		init           : function () {
			this.refresh();
			this.$el.data('op', this).attr('open', true).blur();
			// 如果不允许手动输入，将触发对象设为只读
			if (!this.options.allowEdit) {
				if (this.options.rangeEl && this.options.rangeEl.length) {
					if ($(this.options.rangeEl[0]).is('input')) {
						$(this.options.rangeEl[0]).prop('readonly', true);
						$(this.options.rangeEl[1]).prop('readonly', true);
					}
				}
				else {
					this.$el.prop('readonly', true);
				}
			}
			this.$parent.appendTo(document.body).css({
				left: this.$el.offset().left,
				top : this.$el.offset().top + this.$el.outerHeight()
			}).fadeOut(0).fadeIn();
			this.bindEvent();
		},
		resetDate      : function () {
			var xDate = this.options.date;
			if (xDate instanceof Array) {
				this.startDate = this.__date_string(xDate[0], 'D');
				this.endDate = this.__date_string(xDate[1], 'D');
			}
			else {
				this.startDate = this.__date_string(xDate, 'D');
			}
			if (this.options.showTime) {
				if (this.options.isRange) {
					this.selectStartTime = this.__date_string(xDate[0], 'T');
					this.selectEndTime = this.__date_string(xDate[1], 'T');
				}
				else {
					this.selectStartTime = this.selectEndTime = this.__date_string(xDate, 'T');
				}

				if (!this.options.showSecond) {
					this.selectStartTime = this.selectStartTime.split(':').slice(0, 2).join(':');
					this.selectEndTime = this.selectEndTime.split(':').slice(0, 2).join(':');
				}
			}

			// console.log('--->>>>', xDate, this.startDate, this.endDate, this.selectStartTime);

			if (this.options.isRange) {
				this.cenMonth = new Date(this.endDate).setDate(1);
			}
			else {
				this.cenMonth = new Date(this.startDate).setDate(1);
			}
		},
		getOption      : function () {
			var _option = {
				weekStart: 0,
				weekNames: [],
				allowEdit: false,
				autoClose: false,
				todayBtn : false,
				date     : new Date().setHours(8, 0, 0, 0)
			};
			// 判断是单选还是范围选择
			if (this.$el.data('range')) {
				_option.isRange = true;
			}
			// 判断是否显示时间
			if (
				this.$el.is('[type="datetime-local"]')
				||
				this.$el.data('show-time')
				||
				this.$el.find('input[type="datetime-local"]').length === 2
			) {
				_option.showTime = true;
			}
			// 判断是否最小单位到秒，影响时间输入框的展示
			if (
				_option.showTime
				&&
				this.$el.prop('step') && this.$el.prop('step') < 60
				||
				this.$el.find('input[type="datetime-local"][step]').length === 2
			) {
				_option.showSecond = true;
			}
			// 判断是否有最小值限制
			var sMin = this.$el.prop('min') ? this.$el.prop('min') : this.$el.data('min');
			if (sMin) {
				_option.min = this.__format_string(sMin);
			}
			// 判断是否有最大值限制
			var sMax = this.$el.prop('max') ? this.$el.prop('max') : this.$el.data('max');
			if (sMax) {
				_option.max = this.__format_string(sMax, '23:59:59');
			}
			// 是否允许编辑
			_option.allowEdit = !!this.$el.data('editable');
			// 判断是否选择完自动关闭，仅在单选日期并且不提供手动输入时生效
			if (!_option.isRange && !_option.allowEdit && this.$el.data('auto-close')) {
				_option.autoClose = true;
			}
			// 获取默认的值
			if (_option.isRange) {
				var _input = this.$el.find('input');
				if (_input.length) {
					_option.rangeEl = $.map(_input, function (oItem) {
						$(oItem).attr('min', _option.min).attr('max', _option.max);
						return oItem;
					});
				}
				else {
					_option.rangeEl = $.map(this.$el.find('[role="range"]'), function (oItem) {
						return oItem;
					});
				}
				var _start = new Date(this.__prefix(_option.rangeEl[0].value || _option.rangeEl[0].innerText)).getTime() || new Date().getTime(),
				    _end   = new Date(this.__prefix(_option.rangeEl[1].value || _option.rangeEl[1].innerText)).getTime() || new Date().getTime();

				_option.date = [_start, _end];
			}
			else {
				_option.date = new Date(this.__prefix(this.$el.val() || this.$el.text())).getTime() || new Date().getTime();
			}
			// 获取周起始值
			if (this.$el.data('week-start')) {
				_option.weekStart = this.$el.data('week-start');
				if (_option.weekStart > 7) {
					_option.weekStart = 0;
				}
			}
			// 将配置的周起始值转换为符合程序算法的 0-6
			_option.weekStart = _option.weekStart % 7;
			// 配置周几的标题文字，默认不提供则获取系统自带的
			if (this.$el.data('week-names')) {
				_option.weekNames = this.$el.data('weekNames').split(',');
			}
			// 是否显示跳转到今天按钮
			_option.todayBtn = !!this.$el.data('today');

			return _option;
		},
		bindEvent      : function () {
			var _this = this;
			// 触发对象的操作
			this.$el.off('change').on('change', function (e) {
				var _that = e.target;
				if (_this.options.isRange) {
					if (_that === _this.options.rangeEl[0]) {
						_this.options.date[0] = new Date(_this.__prefix(_that.value)).getTime();
					}
					else if (_that === _this.options.rangeEl[1]) {
						_this.options.date[1] = new Date(_this.__prefix(_that.value)).getTime();
					}
				}
				else {
					_this.options.date = new Date(_this.__prefix(_that.value)).getTime();
				}
				_this.resetDate();
				_this.refresh();
			});
			// 弹出面板的操作
			this.$parent
				.on('click', function () {
					return false;
				})
				.on('change', 'input[type*="date"]', function () {
					if ($(this).is(':first-of-type')) {
						_this.startDate = _this.__date_string(this.value, 'D');
						_this.selectStartTime = _this.__date_string(this.value, 'T');
					}
					else if ($(this).is(':last-of-type')) {
						_this.endDate = _this.__date_string(this.value, 'D');
						_this.selectEndTime = _this.__date_string(this.value, 'T');
					}
					_this.refresh();
				})
				.on('change', '[type="time"]', function () {
					_this.selectStartTime = this.value;
				})
				.on('click', '[role-action]', function () {
					var _action = $(this).attr('role-action');
					if (typeof _this[_action] === 'function') {
						_this[_action]();
					}
				})
				.on('click', 'ul>li', function () {
					var _dataDate = $(this).data('date');
					if (!_dataDate) {
						return;
					}
					var _select = _this.__date_string(_dataDate, 'D');
					if (_this.start || !_this.options.isRange) {
						_this.startDate = _this.endDate = _select;
						_this.start = false;
					}
					else {
						_this.endDate = _select;
						_this.start = true;
					}
					// 日期反转
					if (new Date(_this.endDate) < new Date(_this.startDate)) {
						var _end = _this.startDate;
						_this.startDate = _this.endDate;
						_this.endDate = _end;
					}
					if (_this.options.autoClose) {
						_this.update();
					}
					else {
						_this.refresh();
					}
				});
		},
		dismiss        : function () {
			this.$el.removeAttr('open').removeData('op');
			this.$parent.fadeOut(function () {
				$(this).remove();
			});
		},
		update         : function () {
			// 输出结果
			var _start = this.startDate,
			    _end   = this.endDate;

			if (this.options.showTime) {
				_start += 'T' + this.selectStartTime;
				_end += 'T' + this.selectEndTime;
			}

			if (this.options.isRange) {
				if ($(this.options.rangeEl[0]).is('input')) {
					this.options.rangeEl[0].value = _start;
					this.options.rangeEl[1].value = _end;
				}
				else {
					this.options.rangeEl[0].innerHTML = _start.replace('T', ' ');
					this.options.rangeEl[1].innerHTML = _end.replace('T', ' ');
				}
			}
			else {
				if (this.$el.is('input')) {
					if (this.$el.is('[type*="date"]')) {
						this.$el.val(_start);
					}
					else {
						this.$el.val(_start.replace('T', ' '));
					}
				}
				else {
					this.$el.html(_start.replace('T', ' '));
				}
			}
			this.$el[0].dispatchEvent(new CustomEvent('change', {detail: {start: _start, end: _end}}));

			// console.log('update', this.startDate, this.endDate, this.selectStartTime);
			this.dismiss();
		},
		prevYear       : function () {
			var _date = new Date(this.cenMonth);
			this.cenMonth = _date.setFullYear(_date.getFullYear() - 1);
			this.refresh();
		},
		prevMonth      : function () {
			var _date = new Date(this.cenMonth);
			this.cenMonth = _date.setMonth(_date.getMonth() - 1);
			this.refresh();
		},
		nextYear       : function () {
			var _date = new Date(this.cenMonth);
			this.cenMonth = _date.setFullYear(_date.getFullYear() + 1);
			this.refresh();
		},
		nextMonth      : function () {
			var _date = new Date(this.cenMonth);
			this.cenMonth = _date.setMonth(_date.getMonth() + 1);
			this.refresh();
		},
		today          : function () {
			this.cenMonth = new Date().setDate(1);
			this.refresh();
		},
		refresh        : function () {
			// 刷新日历列表
			var sBuild = '';
			var _range = this.options.isRange
				? [this.startDate, this.endDate]
				: [this.startDate, this.startDate];
			if (this.options.isRange) {
				this.preMonth = new Date(new Date(this.cenMonth).setDate(0)).setDate(1);
				sBuild += '\
							<dl>\
								<dt>' + new Date(this.preMonth).toLocaleString('nu', {year: 'numeric', month: 'long'}) + '</dt>\
								<dd>' + this.write(this.preMonth, _range) + '</dd>\
							</dl>';
			}
			sBuild += '\
						<dl>\
							<dt>' + new Date(this.cenMonth).toLocaleString('nu', {year: 'numeric', month: 'long'}) + '</dt>\
							<dd>' + this.write(this.cenMonth, _range) + '</dd>\
						</dl>';

			this.$container.html(sBuild);
			// 刷新输入框值
			if (!this.options.autoClose && this.options.allowEdit) {
				if (this.options.isRange) {
					var $input = this.$parent.find('form input');
					if (this.options.showTime) {
						$input.eq(0).val(this.startDate + 'T' + this.selectStartTime);
						$input.eq(1).val(this.endDate + 'T' + this.selectEndTime);
					}
					else {
						$input.eq(0).val(this.startDate);
						$input.eq(1).val(this.endDate);
					}
				}
				else {
					this.$parent.find('form input').val(this.selectStartTime);
				}
			}
		},
		write          : function (nOriginFirstDay, aRangeDate) {
			var _this = this;
			aRangeDate[0] = new Date(aRangeDate[0]).setHours(0, 0, 0, 0);
			aRangeDate[1] = new Date(aRangeDate[1]).setHours(0, 0, 0, 0);
			var nMin = new Date(this.options.min).getTime() || 0,
			    nMax = new Date(this.options.max).getTime() || 63630460800000;
			var dOriginDate = new Date(nOriginFirstDay);
			var nYear  = dOriginDate.getFullYear(),
			    nMonth = dOriginDate.getMonth();
			// 2009-6-1 周一 在日历列表的第2列，依次类推
			var aWeekNumeric = [1243814400000, 1243900800000, 1243987200000, 1244073600000, 1244160000000, 1244246400000, 1244332800000];
			var aWeekOrder = [2, 3, 4, 5, 6, 7, 1];
			aWeekOrder = [].concat(aWeekOrder.slice(-this.options.weekStart), aWeekOrder.slice(0, aWeekOrder.length - (this.options.weekStart || 7)));
			// 获取周几用来计算第一天在数组的第几个位置开始
			var nStartPosition = aWeekOrder[(dOriginDate.getDay() || 7) - 1] - 1;
			// 获取当月最后一天的数字来计算循环次数
			var nLastDay = new Date(nYear, nMonth + 1, 0).getDate();
			// 造当月日历数组
			var aMonth = [];
			var i;
			for (i = 0; i < nLastDay; i++) {
				aMonth[nStartPosition + i] = i + 1;
			}
			// 定义日历表头
			var aHead = [];
			$.each(aWeekOrder, function (nIndex, nPosition) {
				var systemWeekName = new Date(aWeekNumeric[nIndex]).toLocaleString('nu', {weekday: 'short'});
				var settingWeekName = _this.options.weekNames[nIndex];
				aHead[nPosition - 1] = settingWeekName || systemWeekName;
			});
			var nLen = aHead[0].replace(/\w{2}/g, '@').length * 7 + 2;
			var sCalendar = '<ol style="width:' + nLen + 'em;"><li>' + aHead.join('</li><li>') + '</li></ol>';
			// 对数组前面的空项进行构造，并在下面 reduce 开始时补上空 DOM 结构
			sCalendar += '<ul style="width:' + nLen + 'em;">';
			for (i = 0; i < aMonth.length; i++) {
				var nItemDay = aMonth[i];
				if (!nItemDay) {
					sCalendar += '<li></li>';
				}
				else {
					var dIndexDate = new Date(nYear, nMonth, nItemDay);
					var _class = [],
					    _title = '',
					    _data  = ' data-date="' + dIndexDate.getTime() + '"';
					if (new Date().setHours(0, 0, 0, 0) === dIndexDate.getTime()) {
						_class.push('today');
					}

					if (dIndexDate.getTime() >= aRangeDate[0] && dIndexDate.getTime() <= aRangeDate[1]) {
						_class.push('selected');

						if (dIndexDate.getTime() === aRangeDate[1]) {
							_class.push('last-of');
						}
						else if (dIndexDate.getTime() === aRangeDate[0]) {
							_class.push('first-of');
						}
					}

					if (nMax
						&& new Date(nMax).setHours(0, 0, 0, 0) < dIndexDate.getTime()
						|| nMin
						&& new Date(nMin).setHours(0, 0, 0, 0) > dIndexDate.getTime()
					) {
						_class.push('disabled');
						_data = '';
					}

					_class = _class.length ? ' class="' + _class.join(' ') + '"' : '';
					_title = dIndexDate.toLocaleString('nu', {
						year : 'numeric',
						month: 'long',
						day  : 'numeric'
					});

					sCalendar += '<li title="' + _title + '"' + _data + _class + '>' + nItemDay + '</li>';
				}
			}
			sCalendar += '</ul>';

			return sCalendar;
		}
	};

});
